import React from 'react';
import IndexRoute from '../IndexRoute';
import Redirect from '../Redirect';
export var fromReactTreeToJSON = function fromReactTreeToJSON(root, parent, level) {
  if (parent === void 0) {
    parent = {};
  }

  if (level === void 0) {
    level = 1;
  }

  if (!React.isValidElement(root)) {
    return null;
  }

  var _root$props = root.props,
      component = _root$props.component,
      path = _root$props.path,
      children = _root$props.children,
      getComponent = _root$props.getComponent,
      id = _root$props.id,
      from = _root$props.from,
      to = _root$props.to;
  var type = root.type;
  var node = Object.create(null);
  if (type.displayName === Redirect.displayName) node.redirect = true;
  if (type.displayName === Redirect.displayName) node.from = from;
  if (type.displayName === Redirect.displayName) node.path = from;
  if (type.displayName === Redirect.displayName) node.to = to;

  if (type.displayName === IndexRoute.displayName) {
    node.index = true;
    parent.fromIndex = true;
    parent.indexNode = node;
  }

  if (level) node.level = level;
  if (id) node.id = id;
  if (component) node.component = component;
  if (getComponent) node.getComponent = getComponent;
  if (path) node.path = path;
  if (children) node.children = React.Children.toArray(children).map(function (child) {
    return fromReactTreeToJSON(child, node, level + 1);
  });
  return node;
};